package renderers.html

import org.jetbrains.dokka.base.DokkaBaseConfiguration.Companion.defaultFooterMessage
import org.jetbrains.dokka.base.renderers.html.HtmlRenderer
import org.jsoup.Jsoup
import org.jsoup.nodes.Element
import org.junit.jupiter.api.Test
import renderers.testPage
import utils.A
import utils.Span
import utils.match

class FooterMessageTest : HtmlRenderingOnlyTestBase() {
    @Test
    fun `should include defaultFooter`() {
        val page = testPage { }
        HtmlRenderer(context).render(page)
        renderedContent.match(
            Span(A()),
            Span(defaultFooterMessage),
            Span(Span("Generated by "), A(Span("dokka"), Span()))
        )
    }

    override val renderedContent: Element
        get() = files.contents.getValue("test-page.html").let { Jsoup.parse(it) }.select(".footer").single()
}